'==========================================================================
'Multispaced font managing routines                     lpardini@cefex.com
'==========================================================================
' For information, press F5.
'==========================================================================
'                                         | I like mail, so contact me for
'__________   ____---____                 | any  doubt or  suggestion  you
'\_________D /-/---_----'            LL&P | have for this/another program,
'       _H__/_/           Leandro Pardini | for  get my  last routines, to
'      '-_____|(       lpardini@cefex.com | chat  about  computers  and/or
'                                         | programming or to say "Hello".
'==========================================================================
'$STATIC
DEFINT A-Z

DECLARE SUB CharPrint (PosX%, PosY%, Char%, Clr%, style%)
DECLARE SUB TextCenter (PosX1%, PosX2%, PosY%, text$, Clr%, style%)
DECLARE SUB TextRight (PosX%, PosY%, text$, Clr%, style%)
DECLARE SUB TextPrint (PosX%, PosY%, text$, Clr%, style%)
DECLARE FUNCTION TextLen% (text$, style%)

CONST True = -1
CONST False = 0

CONST Normal = 0
CONST Italics = 1
CONST Bold = 2

DIM SHARED FontData%(223, 16)
OPEN "DLS.DAT" FOR INPUT AS #25
INPUT #25, fontfile$

'Load the font
OPEN fontfile$ FOR BINARY ACCESS READ AS #1
   IF LOF(1) > 0 THEN
      FOR FontRead% = 0 TO 223
         GET #1, , FontData%(FontRead%, 0)
         FOR FontLine% = 1 TO FontData%(FontRead%, 0)
            GET #1, , FontData%(FontRead%, FontLine%)
         NEXT FontLine%
      NEXT FontRead%
   ELSE
      PRINT "Can't load " + fontfile$
      SYSTEM
   END IF
CLOSE #1

SCREEN 12
INPUT #25, xpos%, ypos%, text$, colr%, fstyle%
TextPrint xpos%, ypos%, text$, colr%, fstyle%
CLOSE #25
'SLEEP
SYSTEM

'========================<lpardini@cefex.com>=
'Shows a character using the multispaced font.
'PosX%  Pixel X position
'PosY%  Pixel Y position
'Char%  iso-8859-1 character code
'Clr%   Color attribute for printing
'Style% Normal, Bold, Italic, or Bold+Italic
'=============================================
SUB CharPrint (PosX%, PosY%, Char%, Clr%, style%)

Letter% = Char% - 32
IF Letter% < 0 THEN Letter% = 0

FOR Show% = 1 TO FontData%(Letter%, 0)
 
   IF (style% AND 1) = 0 THEN
      IF (FontData%(Letter%, Show%) AND 4096) THEN PSET (PosX% + Show%, PosY%), Clr%
      IF (FontData%(Letter%, Show%) AND 2048) THEN PSET (PosX% + Show%, PosY% + 1), Clr%
      IF (FontData%(Letter%, Show%) AND 1024) THEN PSET (PosX% + Show%, PosY% + 2), Clr%
      IF (FontData%(Letter%, Show%) AND 512) THEN PSET (PosX% + Show%, PosY% + 3), Clr%
      IF (FontData%(Letter%, Show%) AND 256) THEN PSET (PosX% + Show%, PosY% + 4), Clr%
      IF (FontData%(Letter%, Show%) AND 128) THEN PSET (PosX% + Show%, PosY% + 5), Clr%
      IF (FontData%(Letter%, Show%) AND 64) THEN PSET (PosX% + Show%, PosY% + 6), Clr%
      IF (FontData%(Letter%, Show%) AND 32) THEN PSET (PosX% + Show%, PosY% + 7), Clr%
      IF (FontData%(Letter%, Show%) AND 16) THEN PSET (PosX% + Show%, PosY% + 8), Clr%
      IF (FontData%(Letter%, Show%) AND 8) THEN PSET (PosX% + Show%, PosY% + 9), Clr%
      IF (FontData%(Letter%, Show%) AND 4) THEN PSET (PosX% + Show%, PosY% + 10), Clr%
      IF (FontData%(Letter%, Show%) AND 2) THEN PSET (PosX% + Show%, PosY% + 11), Clr%
      IF (FontData%(Letter%, Show%) AND 1) THEN PSET (PosX% + Show%, PosY% + 12), Clr%
   ELSE
      IF (FontData%(Letter%, Show%) AND 4096) THEN PSET (PosX% + Show% + 3, PosY%), Clr%
      IF (FontData%(Letter%, Show%) AND 2048) THEN PSET (PosX% + Show% + 3, PosY% + 1), Clr%
      IF (FontData%(Letter%, Show%) AND 1024) THEN PSET (PosX% + Show% + 3, PosY% + 2), Clr%
      IF (FontData%(Letter%, Show%) AND 512) THEN PSET (PosX% + Show% + 2, PosY% + 3), Clr%
      IF (FontData%(Letter%, Show%) AND 256) THEN PSET (PosX% + Show% + 2, PosY% + 4), Clr%
      IF (FontData%(Letter%, Show%) AND 128) THEN PSET (PosX% + Show% + 2, PosY% + 5), Clr%
      IF (FontData%(Letter%, Show%) AND 64) THEN PSET (PosX% + Show% + 1, PosY% + 6), Clr%
      IF (FontData%(Letter%, Show%) AND 32) THEN PSET (PosX% + Show% + 1, PosY% + 7), Clr%
      IF (FontData%(Letter%, Show%) AND 16) THEN PSET (PosX% + Show% + 1, PosY% + 8), Clr%
      IF (FontData%(Letter%, Show%) AND 8) THEN PSET (PosX% + Show%, PosY% + 9), Clr%
      IF (FontData%(Letter%, Show%) AND 4) THEN PSET (PosX% + Show%, PosY% + 10), Clr%
      IF (FontData%(Letter%, Show%) AND 2) THEN PSET (PosX% + Show%, PosY% + 11), Clr%
      IF (FontData%(Letter%, Show%) AND 1) THEN PSET (PosX% + Show%, PosY% + 12), Clr%
   END IF
  
   IF (style% AND 2) THEN
      CharPrint PosX% + 1, PosY%, Char%, Clr%, (style% AND 1)
   END IF

NEXT Show%
     
PosX% = PosX% + FontData%(Letter%, 0) + 1
IF (style% AND 2) THEN PosX% = PosX% + 1

END SUB

'===================<lpardini@cefex.com>=
'Centers a string using multispaced font.
'PosX1% Left pixel X position of area
'PosX2% Right pixel X position of area
'PosY%  Pixel Y position
'Text$  iso-8859-1 string
'Clr%   Color attribute for printing
'Style% Normal, Bold, Italic, or Bold+Italic
'========================================
SUB TextCenter (PosX1%, PosX2%, PosY%, text$, Clr%, style%)
   TextWidth% = TextLen%(text$, style%)
   MidPos% = PosX1% + ((PosX2% - PosX1%) \ 2)
   TextPrint MidPos% - (TextWidth% \ 2), PosY%, text$, Clr%, style%
END SUB

'=========================================<lpardini@cefex.com>=
'Returns the pixel lenght of a string with my multispaced font.
'Text$  iso-8859-1 string
'Style% Normal, Bold, Italic, or Bold+Italic
'==============================================================
FUNCTION TextLen% (text$, style%)
  
   FOR Proc% = 1 TO LEN(text$)
      Letter% = ASC(MID$(text$, Proc%, 1))
      Lenght% = Lenght% + FontData%(Letter% - 32, 0)
      IF (style% AND 2) THEN Lenght% = Lenght% + 1
      Lenght% = Lenght% + 1
   NEXT Proc%
   IF (style% AND 1) THEN Lenght% = Lenght% + 3
   TextLen% = Lenght%

END FUNCTION

'====================<lpardini@cefex.com>=
'Shows a string using my multispaced font.
'PosX%  Pixel X position
'PosY%  Pixel Y position
'Text$  iso-8859-1 string
'Clr%   Color attribute for printing
'Style% Normal, Bold, Italic, or Bold+Italic
'=========================================
SUB TextPrint (PosX%, PosY%, text$, Clr%, style%)
   FOR Proc% = 1 TO LEN(text$)
      Letter% = ASC(MID$(text$, Proc%, 1))
      CharPrint PosX%, PosY%, Letter%, Clr%, style%
   NEXT Proc%
END SUB

'===========================<lpardini@cefex.com>=
'Right-justifies a string using multispaced font.
'PosX%  Right pixel X position
'PosY%  Pixel Y position
'Text$  iso-8859-1 string
'Clr%   Color attribute for printing
'Style% Normal, Bold, Italic, or Bold+Italic
'================================================
SUB TextRight (PosX%, PosY%, text$, Clr%, style%)
   RgtPos% = PosX% - TextLen%(text$, style%)
   TextPrint RgtPos%, PosY%, text$, Clr%, style%
END SUB

