''''''''''''''''''''''''''''''''''''''
' Program    : Plays AVI Files       '
' Name       : OPENAVI Version 0.2   '
' Programmer : Yousuf Philips        '
' Company    : Y P I                 '
' Updated On : 4th of Oct. 1998      '
' Email - [philipz85@hotmail.com]    '
' [http://members.xoom.com/Philipz/] '
''''''''''''''''''''''''''''''''''''''

'/*               Do not edit this file if you distribute it.              */'
'/*  (c) Copyrighted by YPI in 1998 | All Rights Reserved | Public Domain  */'

'/* This program has been created by YPI (Basic Programming Incorporation) */'
'/* as a utility to play uncompressed AVI files.                           */'
'/*                                                                        */'
'/* What's New -                                                           */'
'/*            * Now it plays 24-BIT uncompressed AVIs in GrayScale        */'
'/*            * AVI Image is converted to a BSAVE file for faster loading */'
'/*            (Don't run this program from a floppy disk, it will be slow)*/'
'/*            * When playing large AVIs, it centers the display           */'
'/*            * Delay Function will work perfectly on any PC              */'
'/*                                                                        */'
'/* Some Notes -
'/*            If you want to speed up the AVI playing then you should     */'
'/*            put a comma (') on line 217 of the sub ShowAVI. This will   */'
'/*            cause the AVI to play as fast as it can load.               */'
'/*                                                                        */'
'/*  Running Under real MS-DOS -                                           */'
'/*            If you are not running this program in Windows then you     */'
'/*            run SMARTDRV (Disk Caching Utility), so that the program    */'
'/*            will be fast. (Windows already has disk caching on)         */'                    

'/* An original program created by the professional programmers at YPI.    */'
'/* If you use any of this code in your program then you must credit YPI.  */'
'/* Please send your comments and suggestions to <philipz85@hotmail.com>   */'

'/* YPI has also created a BMP loader, PCX loader and an FLI player. The   */'
'/* source can be gotten from our website <http://members.xoom.com/Philipz/>*/'
'/* The YPI Website has programs for beginners, tutorials and utilities.   */'

DECLARE SUB ShowAVI (FileName$)
DECLARE SUB GetSpeed ()
DECLARE SUB Delay (MiliSeconds%)

TYPE RIFFHeaderType
   ValidID AS STRING * 4          '/* Must be  = 'RIFF'
   SizeOfFile AS LONG             '/* Size of AVI file in bytes
   RIFFFileType AS STRING * 4     '/* RIFF file type - Must be = 'AVI '
END TYPE

TYPE AVIHeader
   ValidID AS STRING * 4          '/* Must be = 'avih'
   BytesInHeader AS LONG          '/* Bytes in AVI Header
   MicrosecPerFrame AS LONG       '/* Number of Milliseconds between each Frame
   MaximumBytesPerSec AS LONG     '/* Number of bytes the system must handle
                                  '/* per second for the avi to run smoothly
   Reserved1 AS LONG              '/* Reserved must be 0
   BitFlags AS LONG               '/* Bit Flags
   TotalFrames AS LONG            '/* Total Number of Frames
   InitialFrame AS LONG           '/* Not Understood
   NoOfStreams AS LONG            '/* Number of Streams
   BufferSize AS LONG             '/* Buffer size to read a frame
   Widthz AS LONG                 '/* Width of AVI
   Heightz AS LONG                '/* Height of AVI
   Scale AS LONG                  '/* Not Understood (Not Important)
   Rate AS LONG                   '/* Not Understood (Not Important)
   Start AS LONG                  '/* Not Understood (Not Important)
   Length AS LONG                 '/* Not Understood (Not Important)
END TYPE

TYPE StreamHeader
    HeaderID AS STRING * 4        '/* Must be  = 'strh'
    BytesInHeader AS LONG         '/* Bytes in Stream Header
    Typez AS STRING * 4           '/* Type of Stream Header
                                  '/* vids - For Video Stream
                                  '/* auds - For Audio Stream
    Handle AS STRING * 4          '/* Name of Compressor
    BitFlags AS LONG              '/* Not Understood (Not Important)
    Reserved1 AS LONG             '/* Not Understood (Not Important)
    InitialFrames AS LONG         '/* Not Understood (Not Important)
    Scale AS LONG                 '/* Not Understood (Not Important)
    Rate AS LONG                  '/* Not Understood (Not Important)
    Start AS LONG                 '/* Not Understood (Not Important)
    Length AS LONG                '/* Not Understood (Not Important)
    BufferSize AS LONG            '/* Not Understood (Not Important)
    Quality AS LONG               '/* Not Understood (Not Important)
    SampleSize AS LONG            '/* Not Understood (Not Important)
END TYPE

TYPE StreamFormat
    StreamFormatID AS STRING * 4  '/* Must be = 'strf'
    BytesInFormat AS LONG         '/* Number of Bytes in Stream Format
END TYPE

TYPE BMPInfoHeader                '/* Windows 3.x BMP Information Header
    SizeOfHeader AS LONG          '/* Number of Bytes of Header = 40
    ImageWidth AS LONG            '/* Width of AVI
    ImageHeight AS LONG           '/* Height of AVI
    Planes AS INTEGER             '/* Planes - Must be 1
    BitsPerPixel AS INTEGER       '/* Bits Per Pixel - 8 or 24
    CompressMethod AS LONG        '/* Compression Method
                                  '/* 0 - Uncompressed
                                  '/* 1 - 8-BIT RLE
                                  '/* 2 - 4-BIT RLE (Impossible)
    ImageSizeInBytes AS LONG      '/* Not Important
    HorizontalRatio AS LONG       '/* Not Important
    VerticalRatio AS LONG         '/* Not Important
    ColorsUsed AS LONG            '/* Not Important
    ImportantColors AS LONG       '/* Not Important
END TYPE

TYPE JunkChunk                    '/* Junk Chunk - Used for padding
   ChunkID AS STRING * 4          '/* Must be = 'JUNK'
   EmptyCharacters AS LONG        '/* Number of empty bytes
END TYPE

TYPE ImageData                   '/* Image Data - Specifies type of Image Data
   ChunkID AS STRING * 4          '/* Type of image data
                                  '/* db - Bitmap Uncompressed data
                                  '/* dc - Bitmap Compressed data
                                  '/* wb - Sound data
                                  '/* pc - Palette Change
   NumberOfBytes AS LONG          '/* Number of Bytes of data
END TYPE

TYPE ChangingPalette              '/* Changing Palette for different colors
   FirstColor AS STRING * 1
   NumberOfColorsToChange AS STRING * 1
   BitFlags AS INTEGER
END TYPE

COMMON SHARED Speed&
IF COMMAND$ <> "" THEN
FileName$ = COMMAND$
CALL GetSpeed

IF LEN(LTRIM$(FileName$)) = 0 THEN
   END
ELSEIF INSTR(FileName$, ".") = 0 THEN
   FileName$ = FileName$ + ".avi"
END IF

CALL ShowAVI(FileName$)

'/* Some ending statements for those how didn't read the comments at the   */'
'/* beginning of the program.                                              */'

Wait$ = INPUT$(1)
WHILE INKEY$ <> "": WEND
ELSE
 PRINT "OpenAVI v0.2"
 PRINT "(C) Data Components Software Development"
 PRINT "Code by: Yousuf Philips of Y P I, Inc."
 PRINT
 PRINT "Usage: OPENAVI[.exe] AVIFILE.AVI"
 SYSTEM
END IF

SUB Delay (MiliSeconds%)
'/* This function creates a delay in [ms] suitable to the current PC       */'

DelayTime = (Speed& * 5) * (MiliSeconds% / 1000)
FOR Speed = 1 TO DelayTime
NEXT Speed

END SUB

SUB GetSpeed
'/* This function calculates a delay period need for the current PC        */'

Time& = TIMER: Time& = Time& + 1: Speed& = 0
DO
LOOP UNTIL TIMER >= Time&
DO
   Speed& = Speed& + 1
LOOP UNTIL TIMER >= Time& + 1

'/* Testing the calculated delay period with the Delay FUNCTION            */'
Time! = TIMER
Delay 1000
Time! = TIMER - Time!

'/* If the Delay FUNCTION was not accurate then it is adjusted             */'
IF Time! < 1 THEN
   Speed& = INT(Speed& * (1 / Time!))
END IF

END SUB

DEFINT A-Z
SUB ShowAVI (FileName$)
                         
'/* Opens the AVI file in BINARY format                                    */'
OPEN FileName$ FOR BINARY AS #255
IF LOF(255) = 0 THEN
   PRINT " FILE IS EMPTY"
   CLOSE #255
   KILL FileName$
   EXIT SUB
END IF

'/* Creates the necessary structure types for easy extraction of data      */'
DIM RIFFHeaderType AS RIFFHeaderType
DIM AVIHead AS AVIHeader
DIM StreamHead AS StreamHeader
DIM StreamForm AS StreamFormat
DIM BMPInfoHead AS BMPInfoHeader
DIM ImageDataz AS ImageData

GET #255, , RIFFHeaderType
'/* Checks if the opened file is an AVI file                               */'
IF RIFFHeaderType.RIFFFileType <> "AVI " THEN
   PRINT " INVALID AVI FILE"
   END
END IF

GET #255, 25, AVIHead
AVIHead.MicrosecPerFrame = AVIHead.MicrosecPerFrame / 1000

'/* Searches through file for the next occurence of 'LIST'                 */'
Search1:
Position& = LOC(255) + 1: DWord$ = SPACE$(4)
DO
GET #255, Position&, DWord$
Position& = Position& + 4
LOOP UNTIL DWord$ = "LIST"
GET #255, , DWord$

GET #255, , DWord$
IF DWord$ = "strl" THEN
   GET #255, , StreamHead
   IF StreamHead.Typez <> "vids" THEN
      Searchz = Searchz + 1
       IF Searchz > 2 THEN
         PRINT " AVI HAS MORE 2 STREAMS WHICH ARENT VIDEO STREAMS"
         END   'EXIT SUB
      END IF
      GOTO Search1
   END IF
   Position& = LOC(255) + 1
   DO
      GET #255, Position&, DWord$
      Position& = Position& + 4
   LOOP UNTIL DWord$ = "strf"
   GET #255, Position& - 4, StreamForm
   GET #255, , BMPInfoHead
   IF BMPInfoHead.CompressMethod <> 0 THEN
      PRINT " THE CURRENT VERSION OF OPENAVI ONLY PLAYS UNCOMPRESSED AVIs"
      END 'EXIT SUB
   END IF
   IF BMPInfoHead.BitsPerPixel = 8 THEN
      Palette$ = SPACE$(1024)
      GET #255, , Palette$
      SCREEN 13
      FOR Loops = 0 TO 255
         OUT &H3C8, Loops
         OUT &H3C9, ASC(MID$(Palette$, (Loops * 4) + 3, 1)) \ 4
         OUT &H3C9, ASC(MID$(Palette$, (Loops * 4) + 2, 1)) \ 4
         OUT &H3C9, ASC(MID$(Palette$, (Loops * 4) + 1, 1)) \ 4
      NEXT Loops
   ELSE
      SCREEN 13
      FOR Loops = 0 TO 255
         OUT &H3C8, Loops
         OUT &H3C9, Loops \ 4
         OUT &H3C9, Loops \ 4
         OUT &H3C9, Loops \ 4
      NEXT Loops
   END IF
ELSE
   PRINT " UNKNOWN AVI FILE FORMAT"
   END 'EXIT SUB
END IF

'/* Calculates the number of bytes that need to be extracted for every line*/'
IF BMPInfoHead.BitsPerPixel = 24 THEN
   Bytes$ = SPACE$(3 * BMPInfoHead.ImageWidth)
   IF 4 - ((BMPInfoHead.ImageWidth * 3) MOD 4) <> 4 THEN
      Bytes$ = Bytes$ + SPACE$(4 - ((BMPInfoHead.ImageWidth * 3) MOD 4))
   END IF
ELSE
   Bytes$ = SPACE$(BMPInfoHead.ImageWidth)
   IF 4 - (BMPInfoHead.ImageWidth MOD 4) <> 4 THEN
      Bytes$ = Bytes$ + SPACE$(4 - (BMPInfoHead.ImageWidth MOD 4))
   END IF
END IF

'/* Creating BSAVE File Header */'
ValidID$ = CHR$(253)
ArraySegment$ = MKL$(0)
IF BMPInfoHead.ImageWidth < 350 THEN
   IF BMPInfoHead.ImageHeight > 200 THEN BMPInfoHead.ImageHeight = 200
   IF BMPInfoHead.ImageWidth > 320 THEN BMPInfoHead.ImageWidth = 320
   MiddleX = (320 - BMPInfoHead.ImageWidth) \ 2
   MiddleY = (200 - BMPInfoHead.ImageHeight) \ 2
   BytesInFile! = BMPInfoHead.ImageWidth * BMPInfoHead.ImageHeight
   IF BytesInFile! > 32767 THEN
      Bytes = BytesInFile! - 65536
   ELSE
      Bytes = BytesInFile!
   END IF
   BytesInFile$ = MKI$(Bytes)
   ImageWidth$ = MKI$(BMPInfoHead.ImageWidth * 8)
   ImageHeight$ = MKI$(BMPInfoHead.ImageHeight)
ELSEIF BMPInfoHead.ImageWidth > 320 AND BMPInfoHead.ImageHeight > 200 THEN
   IF BMPInfoHead.BitsPerPixel = 24 THEN
      SCREEN 2: SCREEN 0
      PRINT " 24-BIT AVI Is To Large, Sorry..."
      END
   END IF
   BytesInFile$ = MKI$(-1536)
   ImageWidth$ = MKI$(320 * 8)
   ImageHeight$ = MKI$(200)
ELSE
   SCREEN 2: SCREEN 0
   PRINT " Width and Height -"; BMPInfoHead.ImageWidth, BMPInfoHead.ImageHeight
   PRINT " Program Has Not Been Programmed For This Resolution AVI File, Sorry.."
   END   'EXIT SUB
END IF
BSAVEFileHeader$ = ValidID$ + ArraySegment$ + BytesInFile$ + ImageWidth$ + ImageHeight$

'/* Searches through file for the next occurence of 'LIST'                */'
Search:
Position& = LOC(255) + 1
DO
GET #255, Position&, DWord$
Position& = Position& + 4
LOOP UNTIL DWord$ = "LIST"
GET #255, , DWord$

Repeatz:
IF Repeat = 1 THEN SEEK #255, MovieStartingPosition&

GET #255, , DWord$
IF DWord$ = "movi" THEN
   MovieStartingPosition& = LOC(255) - 3
   FOR FrameNumber = 1 TO AVIHead.TotalFrames
      GET #255, , ImageDataz
      IF RIGHT$(ImageDataz.ChunkID, 2) = "db" AND BMPInfoHead.BitsPerPixel = 8 THEN
         CurrentLocation& = LOC(255) + 1
         '/* Converts AVI Image into BSAVE file for faster loading         */'
         OPEN "Temp.fil" FOR BINARY AS #254
         PUT #254, , BSAVEFileHeader$
         IF BMPInfoHead.ImageWidth < 321 THEN
            '/* If the AVI is smaller than SCREEN 13                       */'
            FOR YHeight = BMPInfoHead.ImageHeight - 1 TO 0 STEP -1
               '/* Extracts the image data from the AVI file               */'
               GET #255, , Bytes$
               TotalBytes$ = LEFT$(Bytes$, BMPInfoHead.ImageWidth)
               '/* Puts the image data into the BSAVE file                 */'
               PUT #254, 12 + (BMPInfoHead.ImageWidth * YHeight), TotalBytes$
            NEXT YHeight
            MiddleX = (320 - BMPInfoHead.ImageWidth) \ 2
            MiddleY = (200 - BMPInfoHead.ImageHeight) \ 2
         ELSE
            '/* If the AVI is larger than (320 X 200) then it centers the  */'
            '/* display of the AVI                                         */'
            FOR MiddleImage = 1 TO (BMPInfoHead.ImageHeight - 200) \ 2
               GET #255, , Bytes$
            NEXT MiddleImage
            FOR YHeight = 199 TO 0 STEP -1
               '/* Extracts the image data from the AVI file               */'
               GET #255, , Bytes$
               Middle = (BMPInfoHead.ImageWidth - 320) \ 2
               TotalBytes$ = MID$(Bytes$, Middle, 320)
               '/* Puts the image data into the BSAVE file                 */'
               PUT #254, 12# + (320# * YHeight), TotalBytes$
            NEXT YHeight
         END IF
         CLOSE #254
         '/* Loads BSAVE image from file and place image on screen         */'
         REDIM PictureArray(1 TO 32767)
         DEF SEG = VARSEG(PictureArray(1))
         BLOAD "Temp.fil", VARPTR(PictureArray(1))
         DEF SEG
         PUT (MiddleX, MiddleY), PictureArray, PSET
         SEEK #255, CurrentLocation& + ImageDataz.NumberOfBytes
      ELSEIF RIGHT$(ImageDataz.ChunkID, 2) = "db" AND BMPInfoHead.BitsPerPixel = 24 THEN
         FOR YHeight = BMPInfoHead.ImageHeight - 1 TO 0 STEP -1
            '/* Extracts the image data from the AVI file               */'
            GET #255, , Bytes$
            FOR XWidth = 0 TO BMPInfoHead.ImageWidth - 1
               PSET (XWidth + MiddleX, YHeight + MiddleY), ASC(MID$(Bytes$, (XWidth * 3) + 1, 1))
            NEXT XWidth
         NEXT YHeight
      ELSEIF RIGHT$(ImageDataz.ChunkID, 2) = "pc" THEN
         '/* Skipping the color changing                                   */'
         'GET #255, , ChangePalette
         PRINT " SEND THIS AVI File To The Following Email. Thanks"
         PRINT " philipz85@hotmail.com": END
      ELSEIF RIGHT$(ImageDataz.ChunkID, 2) = "wb" THEN
         '/* Skipping the sound part of the AVI if there is.               */'
         SEEK #255, LOC(255) + 1 + ImageDataz.NumberOfBytes
         FrameNumber = FrameNumber - 1
      ELSEIF RIGHT$(ImageDataz.ChunkID, 2) = "dc" THEN
         SCREEN 2: SCREEN 0
         PRINT " ONLY UNCOMPRESSED AVI SEQUENCIES CAN BE SHOWN"
         END
      ELSE
         SCREEN 2: SCREEN 0
         PRINT " SOMETHING IS WRONG"
         END
      END IF
      '/* Creates a delay according to the AVI File                        */'
      Delay (AVIHead.MicrosecPerFrame)
      IF INKEY$ <> "" THEN
          IF BMPInfoHead.BitsPerPixel = 8 THEN
             KILL "Temp.fil"
          END IF
         CLOSE : EXIT SUB
      END IF
   NEXT FrameNumber
ELSE
   GOTO Search
END IF

Repeat = 1: GOTO Repeatz

END SUB

