'''''''''''''''''''''''''''''''''''''''''''
' Program    : Loads LBM/IFF Files        '
' Name       : OPENLBM Version 0.1        '
' Programmer : Yousuf Philips             '
' Company    : Y P I                      '
' Updated On : 12th of June 1999          '
' Email      : philipz85@hotmail.com      '
' Website    : http://www.philipz.com/qb/ '
'''''''''''''''''''''''''''''''''''''''''''

'/*               Do not edit this file if you distribute it.              */'
'/*  (c) Copyrighted by YPI in 1998 | All Rights Reserved | Public Domain  */'

'/* This program has been created by YPI (Basic Programming Incorporation) */'
'/* as a utility to load Deluxe Paint Uncompressed Image files [IFF/LBM].  */'
'/* This program currently loads 4 & 8-bit uncompressed LBM files.         */'

'/* If you use any of this code in your program then you must credit YPI.  */'
'/* YPI has created an assortment of Image viewers and players and they    */'
'/* can all be found at <http://www.philipz.com/qb/>                       */'
'/* Please send comments & suggestions to philipz85@hotmail.com            */'

DECLARE FUNCTION Bin2Dec% (Bin$)                'Converts Binary to Decimal
DECLARE FUNCTION Decimal2Binary$ (Number%)      'Converts Decimal to Binary
DECLARE FUNCTION Intel2MotorolaLong& (Longs&)   'Converts Intel 2 Motorola
DECLARE FUNCTION Intel2MotorolaInt% (Integerx%) 'Converts Intel 2 Motorola
DECLARE SUB OpenLBM (FileName$)

TYPE IFFHeader
   ValidID AS STRING * 4          ' Must be 'FORM'
   SizeOfFile AS LONG             ' Size of File - 8 (Motorola)
   IFFType AS STRING * 4          ' Must be 'ILBM'
END TYPE

TYPE IFFRecord
   ID AS STRING * 4               ' Must be 'BMHD'
   SizeOfBlock AS LONG            ' Size of Block
END TYPE

TYPE BMHDHeader
   ImageWidth AS INTEGER          ' Width of Image
   ImageHeight AS INTEGER         ' Height of Image
   Reserved AS STRING * 4         ' ??
   BitsPerPixel AS STRING * 1     ' Bits Per Pixel
   Reserved1 AS STRING * 1        ' ??
   Compression AS STRING * 1      ' Compression
                                  ' 0 [UnCompressed]
                                  ' 1 [Compressed]
   Reserved2 AS STRING * 9        ' ??
END TYPE

ON ERROR GOTO Errrr
IF COMMAND$ <> "" THEN
FileName$ = COMMAND$
CALL OpenLBM(FileName$)
SYSTEM
ELSE
  PRINT "OpenLBM v0.1"
  PRINT "(C) Data Components Software Development"
  PRINT "Code by: Yousuf Philips of Y P I, Inc."
  PRINT
  PRINT "Usage: OPENLBM[.exe] LBMFILE.LBM"
  SYSTEM
END IF
Errrr:
RESUME NEXT

DEFINT A-Z
FUNCTION Bin2Dec (Bin$)

FOR Loops = 1 TO LEN(Bin$)
   IF MID$(Bin$, Loops, 1) = "1" THEN
      Decimal = Decimal + (2 ^ (LEN(Bin$) - Loops))
   END IF
NEXT Loops
Bin2Dec = Decimal

END FUNCTION

FUNCTION Decimal2Binary$ (Number)

FOR Loops = 7 TO 0 STEP -1
   IF (Number AND 2 ^ Loops) = 0 THEN
      Word$ = Word$ + "0"
   ELSE
      Word$ = Word$ + "1"
   END IF
NEXT Loops
Decimal2Binary$ = Word$

END FUNCTION

FUNCTION Intel2MotorolaInt (Integerx)

Integerx$ = MKI$(Integerx)
HighLowByte& = ASC(LEFT$(Integerx$, 1)) * 256 + ASC(RIGHT$(Integerx$, 1))
Intel2MotorolaInt = (HighLowByte& AND 32767) - (HighLowByte& AND 32768)

END FUNCTION

FUNCTION Intel2MotorolaLong& (Longs&)

Longx$ = MKL$(Longs&)
FirstHalf& = ASC(LEFT$(Longx$, 1)) * 256# + ASC(MID$(Longx$, 2, 1))
SecondHalf& = ASC(MID$(Longx$, 3, 1)) * 256# + ASC(RIGHT$(Longx$, 1))
Longz# = FirstHalf& * 65536 + SecondHalf&
Intel2MotorolaLong& = Longz#

END FUNCTION

SUB OpenLBM (FileName$)

DIM IFFHeader AS IFFHeader
DIM IFFRecord AS IFFRecord
DIM BMHDHeader AS BMHDHeader

CLS
OPEN FileName$ FOR BINARY AS #1
IF LOF(1) = 0 THEN
   PRINT " File Is Empty"
   CLOSE
   KILL FileName$
   EXIT SUB
END IF

GET #1, , IFFHeader
IF IFFHeader.ValidID <> "FORM" THEN
   PRINT " Invalid IFF File"
   EXIT SUB
ELSE
   PRINT " Valid IFF File"
END IF
IF IFFHeader.IFFType <> "ILBM" THEN
   PRINT "  Invalid LBM Image File"
   EXIT SUB
ELSE
   PRINT "  Valid LBM Image File"
END IF

DO
   GET #1, , IFFRecord
   Position# = LOC(1) + 1
   IF IFFRecord.ID = "BMHD" THEN
      GET #1, , BMHDHeader
      ImageWidth = Intel2MotorolaInt(BMHDHeader.ImageWidth)
      ImageHeight = Intel2MotorolaInt(BMHDHeader.ImageHeight)
      BitsPerPixel = ASC(BMHDHeader.BitsPerPixel)
      Compression = ASC(BMHDHeader.Compression)
      PRINT "  Image Width -"; ImageWidth
      PRINT "  Image Height -"; ImageHeight
      PRINT "  Bits Per Pixel -"; BitsPerPixel
      PRINT "  Compression -";
      IF Compression = 0 THEN
         PRINT " Not Compressed"
      ELSE
         PRINT " Compressed [Can't be loaded]"
         EXIT SUB
      END IF
      IF (ImageWidth MOD 8) <> 0 THEN
         PRINT "  Image Can't Be Loaded Due To Its Size"
         PRINT "  Please Resize The Image To"; (((ImageWidth \ 8) + 1) * 8); "X"; ImageHeight
         EXIT SUB
      ELSEIF (BitsPerPixel MOD 4) <> 0 THEN
         PRINT "  Irregular Image Depth"
         PRINT "  Please Made Depth 8-bit or 4-bit"
         EXIT SUB
      END IF
      Waiting$ = INPUT$(1)
   ELSEIF IFFRecord.ID = "CMAP" OR IFFRecord.ID = "CRGN" THEN
      Palette$ = SPACE$((2 ^ BitsPerPixel) * 3)
      GET #1, , Palette$
      SCREEN 13
      OUT &H3C8, 0
      FOR Loops = 0 TO (2 ^ BitsPerPixel) - 1
         OUT &H3C9, ASC(MID$(Palette$, Loops * 3 + 1, 1)) \ 4
         OUT &H3C9, ASC(MID$(Palette$, Loops * 3 + 2, 1)) \ 4
         OUT &H3C9, ASC(MID$(Palette$, Loops * 3 + 3, 1)) \ 4
      NEXT Loops
   ELSEIF IFFRecord.ID = "BODY" THEN
      IF Compression = 0 THEN
         DIM ExtractZ$(BitsPerPixel)
         Extract$ = SPACE$(ImageWidth / 8)
         FOR YHeight = 0 TO ImageHeight - 1
            FOR Loops = 1 TO BitsPerPixel
               GET #1, , Extract$
               ExtractZ$(Loops) = Extract$
            NEXT Loops
            FOR XWidth = 0 TO ImageWidth - 1 STEP 8
               First1$ = Decimal2Binary(ASC(MID$(ExtractZ$(1), (XWidth \ 8) + 1, 1)))
               First2$ = Decimal2Binary(ASC(MID$(ExtractZ$(2), (XWidth \ 8) + 1, 1)))
               First3$ = Decimal2Binary(ASC(MID$(ExtractZ$(3), (XWidth \ 8) + 1, 1)))
               First4$ = Decimal2Binary(ASC(MID$(ExtractZ$(4), (XWidth \ 8) + 1, 1)))
               IF BitsPerPixel = 4 THEN
                  FOR Loops = 1 TO 8
                     PixelColor = Bin2Dec(MID$(First4$, Loops, 1) + MID$(First3$, Loops, 1) + MID$(First2$, Loops, 1) + MID$(First1$, Loops, 1))
                     PSET (XWidth + Loops - 1, YHeight), PixelColor
                  NEXT Loops
               ELSEIF BitsPerPixel = 8 THEN
                  First5$ = Decimal2Binary(ASC(MID$(ExtractZ$(5), (XWidth \ 8) + 1, 1)))
                  First6$ = Decimal2Binary(ASC(MID$(ExtractZ$(6), (XWidth \ 8) + 1, 1)))
                  First7$ = Decimal2Binary(ASC(MID$(ExtractZ$(7), (XWidth \ 8) + 1, 1)))
                  First8$ = Decimal2Binary(ASC(MID$(ExtractZ$(8), (XWidth \ 8) + 1, 1)))
                  FOR Loops = 1 TO 8
                     PixelColor = Bin2Dec(MID$(First8$, Loops, 1) + MID$(First7$, Loops, 1) + MID$(First6$, Loops, 1) + MID$(First5$, Loops, 1) + MID$(First4$, Loops, 1) + MID$(First3$, Loops, 1) + MID$(First2$, Loops, 1) + MID$(First1$, Loops, 1))
                     PSET (XWidth + Loops - 1, YHeight), PixelColor
                  NEXT Loops
               END IF
            NEXT XWidth
         NEXT YHeight
      END IF
   ELSE
      IF LOC(1) + 1 >= LOF(1) THEN EXIT DO
   END IF
   SEEK #1, Position# + Intel2MotorolaLong(IFFRecord.SizeOfBlock)
LOOP
Wait$ = INPUT$(1)
CLOSE

END SUB

