''''''''''''''''''''''''''''''''''''''''''''''
' Program    : Display ZIP File Information  '
' Name       : ZIP Viewer Version 1.0        '
' Programmer : Yousuf Philips                '
' Company    : Y P I                         '
' Updated On : 28th June 1998                '
' Email      : philipz85@hotmail.com         '
' Website    : http://www.philipz.com/qb/    '
''''''''''''''''''''''''''''''''''''''''''''''

'/*               Do not edit this file if you distribute it.              */'
'/*  (c) Copyrighted by YPI in 1998 | All Rights Reserved | Public Domain  */'

'/* This program has been created by YPI (Basic Programming Incorporation) */'
'/* as a utility to display file information of files stored a ZIP file.   */'

'/* I had released the executable version of this program on the YPI site  */'
'/* since the first time I started the website, but have just gotten       */'
'/* around to releasing the source code. The major thing that I learnt     */'
'/* from the ZIP file format, was that a date and time stamp can be stored */'
'/* in 2 bytes each. I was using a library previously to convert the bytes */'
'/* to binary in order to read the data, but found two binary conversion   */'
'/* subs, from somewhere as I can't remember and was able to modify the    */'
'/* code so that it will run in Qb 1.1                                     */'

'/* If you use any of this code in your program then you must credit YPI.  */'
'/* I would like to thank who ever wrote the two binary conversion subs.   */'
'/* YPI has created an assortment of graphics loaders and players and they */'
'/* can all be found at <http://www.philipz.com/qb/>                       */'

DECLARE FUNCTION todec$ (b$)
DECLARE FUNCTION tobin$ (n!)
DECLARE SUB OpenZIP (FileName$, PageWize!)
'$DYNAMIC

CommandLine$ = COMMAND$
CommandLine$ = LTRIM$(RTRIM$(CommandLine$))
'CommandLine$ = "you.zip /P"
IF CommandLine$ = "" OR CommandLine$ = "/?" THEN
     PRINT " Open ZIP Files Ver [1.0] - (C) Data Components Software Development"
     PRINT " Code by: Yousuf Philips of Y P I, Inc."
     PRINT
     PRINT " Syntax :-: PK FileName.zip [Options]"
     PRINT " Options :-:"
     PRINT "            /?    - This Help Menu"
     PRINT "            /P    - Page Wize"
     PRINT " Example : - PK QBASIC.ZIP"
     END
END IF

'/* Locating the (.) char in CommandLine$, so that the file name can be */'
'/* extracted from CommandLine$ */'
PositionOfPeriod = INSTR(CommandLine$, ".")
'/* If the (.) char can't be located in CommandLine$, then a line of text is */'
'/* printed and the program ends */'
IF PositionOfPeriod = 0 THEN
   PRINT "FILE NAME IS NOT SPECIFIED. PLEASE TYPE 'PK /?' FOR PROPER SYNTAX"
   END
END IF

'/* The file name is then extracted from CommandLine$ */'
Extension = (INSTR(PositionOfPeriod, CommandLine$, " ") - PositionOfPeriod - 1)
IF Extension < 1 THEN Extension = LEN(CommandLine$) - PositionOfPeriod
FileName$ = LEFT$(CommandLine$, PositionOfPeriod + Extension)
'IF LEN(FileName$) > 12 OR Extension > 3 THEN
'   PRINT " FILE NAME IS ENTERED IN CORRECTLY. PLEASE TYPE 'PK /?' FOR PROPER SYNTAX"
'   END
'END IF

PageWize = (INSTR(CommandLine$, "/P"))
CALL OpenZIP(FileName$, PageWize)

REM $STATIC
SUB OpenZIP (FileName$, PageWize)

'/* Opens the specified File */'
OPEN FileName$ FOR BINARY AS #1
'/* If the file specified is empty then it deletes the file */'
IF LOF(1) = 0 THEN
   PRINT " THE FILE SPECIFIED IS EMPTY. TYPE 'PK /?' FOR SYNTEX"
   CLOSE #1
   KILL FileName$
   END
END IF

ValidPK$ = SPACE$(4)
1 GET #1, , ValidPK$                                           '1'
'/* If ValidPK$<>'PK' then it is not a valid PKZip file */'
IF LEFT$(ValidPK$, 2) <> "PK" THEN
   IF Loops = 1 THEN
      GOTO 12
   ELSE
      PRINT " THIS IS AN INVALID ZIP FILE"
      CLOSE #1
      END
   END IF
END IF

IF Loops = 0 THEN
   PRINT
   PRINT " Length    Compres  Ratio     Date      Time    FileName"
   PRINT " --------+---------+-----+------------+-------+----------"
   Loops = 1
END IF

'/* Extracts the minimum PK version need to extract this file */'
PKVersion$ = SPACE$(2)
GET #1, , PKVersion$                                         '5'
PKVersion = CVI(PKVersion$)
'IF PKVersion = 20 THEN PKVersion$ = "2.0"
'PRINT "Version Needed to open this PKzip is Version "; PKVersion$

'/* Extracts some general information about the zip file */'
GeneralInfo$ = SPACE$(2)
GET #1, , GeneralInfo$                                     '7'
GeneralInfo = CVI(GeneralInfo$)
IF GeneralInfo = 0 THEN
'   PRINT "Could be Encrypted File"
ELSEIF GeneralInfo = 2 THEN
'   PRINT "Shanon - Fano trees were used"
ELSEIF GeneralInfo = 3 OR GeneralInfo = 4 THEN
'   PRINT "The General Information has been damaged": END
END IF

'/* Extracts the Compression Method used on the coming file */'
CompressionMethod$ = SPACE$(2)
GET #1, , CompressionMethod$                                '9'
CompressionMethod = CVI(CompressionMethod$)
'PRINT CompressionMethod$
IF CompressionMethod = 0 THEN
'   PRINT "No Compression - File Just stored"
ELSEIF CompressionMethod = 8 THEN
'   PRINT "Compression Method - DefaltX"
END IF

'/* Extracts the date and time for the coming file */'
TimeOfFile$ = SPACE$(2)
GET #1, , TimeOfFile$                                        '11'
'/* Converting the time to a number and extracting the hours, minutes and */'
'/* seconds from the 16-bit number. Hour is bits 16-12, Minutes is bits 11-6 */'
'/* and seconds is bits 5-1 (seconds has to be multiplied by 2 (0-29)) */'
TimeOfFile = CVI(TimeOfFile$)
IF TimeOfFile < 0 THEN TimeOfFile = TimeOfFile + 65536
TimeOfFile$ = tobin$(TimeOfFile)
Hour$ = LEFT$(TimeOfFile$, 5)
Min$ = MID$(TimeOfFile$, 6, 6)
Sec$ = RIGHT$(TimeOfFile$, 5)
Timez$ = todec$(Hour$) + ":" + todec$(Min$)

DateOfFile$ = SPACE$(2)
GET #1, , DateOfFile$                                      '13'
'/* Converting the date to a number and extracting the year, month and day */'
'/* from the 16-bit number. Year is bits 16-10 and then added to 1980, month */'
'/* is bits 9-6 and day is bits 5-1 */'
DateOfFile = CVI(DateOfFile$)
IF DateOfFile < 0 THEN DateOfFile = DateOfFile + 65536
DateOfFile$ = tobin$(DateOfFile)
Year$ = LEFT$(DateOfFile$, 7)
Month$ = MID$(DateOfFile$, 8, 4)
Day$ = RIGHT$(DateOfFile$, 5)
Datez$ = todec$(Month$) + "-" + todec$(Day$) + "-" + LTRIM$(STR$(VAL(todec$(Year$)) + 1980))

Bit32$ = SPACE$(4)
GET #1, , Bit32$                                           '15'
'Bit32 = CVL(Bit32$)   'Not Important'

CompressedSize$ = SPACE$(4): UnCompressedSize$ = SPACE$(4)
GET #1, , CompressedSize$                                    '19'
GET #1, , UnCompressedSize$                                  '23'
CompressedSize = CVL(CompressedSize$): CompressedSize$ = LTRIM$(STR$(CompressedSize))
UnCompressedSize = CVL(UnCompressedSize$): UnCompressedSize$ = LTRIM$(STR$(UnCompressedSize))
IF UnCompressedSize <> 0 THEN
   CompressedPercent = CINT(((UnCompressedSize - CompressedSize) / UnCompressedSize) * 100)
   CompressedPercent$ = LTRIM$(STR$(CompressedPercent))
END IF
IF LEN(UnCompressedSize$) > 8 THEN GOTO 12

FileNameLength$ = SPACE$(2): ExtraFieldLength$ = SPACE$(2)
GET #1, , FileNameLength$                                         '27'
GET #1, , ExtraFieldLength$                                       '29'
ExtraField = CVI(ExtraFieldLength$)
FileName$ = SPACE$(CVI(FileNameLength$))

GET #1, , FileName$                                               '31'
IF LTRIM$(RTRIM$(FileName$)) = "" THEN GOTO 12

'/* Adds the Uncompressed and Compressed sizes to the total Uncompressed */'
'/* and compressed so that calculation of overall compressed and uncompressed */'
'/* can be calculated */'
TotalUnCompress& = TotalUnCompress& + UnCompressedSize
TotalCompress& = TotalCompress& + CompressedSize

'/* Printing the information of each file in the zip onto the screen */'
PRINT SPACE$(8 - LEN(UnCompressedSize$)); UnCompressedSize$ + " | ";
PRINT SPACE$(7 - LEN(CompressedSize$)); CompressedSize$ + " |";
PRINT SPACE$(3 - LEN((CompressedPercent$))); CompressedPercent$ + "%" + " | ";
PRINT SPACE$(10 - LEN(Datez$)); Datez$ + " | ";
PRINT SPACE$(5 - LEN(Timez$)); Timez$ + " | ";
PRINT FileName$
NoOfFilez = NoOfFilez + 1

MinimumAmount = 21767
IF CompressedSize + ExtraField > MinimumAmount THEN
   ExtraField$ = SPACE$(MinimumAmount)
   DO
      CompressedSize = CompressedSize - MinimumAmount
      GET #1, , ExtraField$
   LOOP UNTIL CompressedSize + ExtraField < MinimumAmount
END IF
ExtraField$ = SPACE$(CompressedSize + ExtraField)
GET #1, , ExtraField$                                             '31+FileNameLength'
ExtraField$ = ""
IF PageWize <> 0 THEN
   IF NoOfFilez < 24 AND NoOfFilez MOD 21 = 0 THEN
      in$ = INPUT$(1)
   ELSEIF NoOfFilez > 24 AND NoOfFilez MOD 22 = 0 THEN
      in$ = INPUT$(1)
   END IF
END IF

GOTO 1

12
'/* Prints the ending information onto the screen */'
PRINT " --------+---------+-----+------------+-------+----------"
TotalUnCompress$ = LTRIM$(STR$(TotalUnCompress&))
TotalCompress$ = LTRIM$(STR$(TotalCompress&))
TotalRatio$ = LTRIM$(STR$(CINT(((TotalUnCompress& - TotalCompress&) / TotalUnCompress&) * 100)))
PRINT SPACE$(8 - LEN(TotalUnCompress$)); TotalUnCompress$ + " |";
PRINT SPACE$(8 - LEN(TotalCompress$)); TotalCompress$ + " |";
PRINT SPACE$(3 - LEN(TotalRatio$)); TotalRatio$ + "%" + " |";
PRINT "                    | Total Files -"; NoOfFilez
CLOSE #1

END SUB

FUNCTION tobin$ (n)
' convert an integer value into a binary string, e.g 4 becomes "100"
' nm% is the value to convert.

a$ = ""
'n% = nm%: ' needed because despite what Help says, num% will be changed :(
   WHILE n > 0
      bit% = n MOD 2
      n = INT(n / 2)
      a$ = RIGHT$(STR$(bit%), 1) + a$
   WEND
IF LEN(a$) <> 16 THEN a$ = STRING$(16 - LEN(a$), "0") + a$
tobin$ = a$
END FUNCTION

FUNCTION todec$ (b$)
' convert
'a string of 1's and 0's into it's decimal equivilant
' could be tweaked for speed, but not a lot
' YPI - the number is changed back into a string for printing purposes '

   FOR k% = LEN(b$) TO 1 STEP -1
      IF MID$(b$, k%, 1) = "1" THEN d% = d% + (2 ^ (LEN(b$) - k%))
   NEXT
d$ = LTRIM$(STR$(d%))
IF LEN(d$) <> 2 THEN d$ = "0" + d$
todec$ = d$
END FUNCTION

